#if !defined(AFX_COPYFILES_H__12E4AA55_C6AA_4C8A_8CD7_62B7620DE521__INCLUDED_)
#define AFX_COPYFILES_H__12E4AA55_C6AA_4C8A_8CD7_62B7620DE521__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CopyFiles.h : header file
//

#include "EditWhite.h"


// Worker thread param
struct COPYPARAM
{
	COPYPARAM() { Zero(); };
	void Zero()
	{
		ZeroMemory(this, sizeof(COPYPARAM));
		hwndDlg		= NULL;
		pEvent		= NULL;
		dirFrom		= NULL;
		dirTo		= NULL;
		bUseTitles	= NULL;
		itemAr		= NULL;
	};

	HWND hwndDlg;
    CEvent * pEvent;
	CString * dirFrom;
	CString * dirTo;
	BOOL * bUseTitles;
	CItemArray * itemAr;
};

// Worker Thread function.
UINT CopyFilesThread(LPVOID pParam);

// Thread lParam message enums
enum COPYMSG { cmInvalid, cmStepIt, cmDone, cmCancel, cmError };

#define COPYSTR _T("Copy Files")
#define CANCELSTR _T("Cancel")


// SHBrowseForFolder callback.
int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, 
								LPARAM lParam, LPARAM lpData);


/////////////////////////////////////////////////////////////////////////////
// CCopyFiles dialog

class CCopyFiles : public CDialog
{
// Construction
public:
	CCopyFiles(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CCopyFiles)
	enum { IDD = IDD_DLG_COPY_FILES_TO };
	CProgressCtrl	m_ctrlProgress;
	CButton		m_ctrlClose;
	CButton		m_ctrlUseTitles;
	CButton		m_ctrlUseNames;
	CButton		m_ctrlCopy;
	CEditWhite	m_ctrlEditTo;
	CString		m_strHeader;
	CString		m_strFolderPath;
	BOOL		m_bUseNames;
	BOOL		m_bUseTitles;
	//}}AFX_DATA
	//CEditWhite


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCopyFiles)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCopyFiles)
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonBrowse();
	afx_msg void OnButtonCopy();
	afx_msg void OnCheckFileNames();
	afx_msg void OnCheckTitles();
	virtual void OnOK();
	//}}AFX_MSG

	afx_msg LRESULT OnCopyThreadMessage(WPARAM wParam, LPARAM lParam);	// WM_USER_COPY_THREAD

	DECLARE_MESSAGE_MAP()

private:
	void CleanTitlePath(CString & str, int maxLen);
	BOOL CopyVideoFiles();

public:
	CItemArray m_itemAr;
	int		m_nFilesCopied;
	CString m_strMessage;

private:
	// Thread param data.
    CEvent	m_event;
	HANDLE	m_hCopyThread;
	CString m_dirFrom;
	CString m_dirTo;
	BOOL	m_useTitles;
	COPYPARAM m_copyThreadParam;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COPYFILES_H__12E4AA55_C6AA_4C8A_8CD7_62B7620DE521__INCLUDED_)
