/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

#if !defined(AFX_FONTSETUP_H__A0348BFB_96E1_4B15_BB8D_EAAA2A729784__INCLUDED_)
#define AFX_FONTSETUP_H__A0348BFB_96E1_4B15_BB8D_EAAA2A729784__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FontSetup.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFontSetup dialog

//
// CFontDialog could be used instead of all this.
// But it will not display all weights (sometimes 3),
// and missing heights can be confusing to users.
// CFontDialog can be modified somewhat, but this is
// about the same amount of work (?).
//

class CFontSetup : public CDialog
{
// Construction
public:
	CFontSetup(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CFontSetup)
	enum { IDD = IDD_DIALOG_FONTS };
	CListBox	m_ctrlListBox;
	CStatic		m_ctrlSample;
	CComboBox	m_ctrlHeight;
	CComboBox	m_ctrlWeight;
	CString		m_strCurFontName;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFontSetup)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CFontSetup)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeListFonts();
	afx_msg void OnKillfocusHeight();
	afx_msg void OnSelchangeHeight();
	afx_msg void OnKillfocusWeight();
	afx_msg void OnSelchangeWeight();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void	FillCombos();
	void	FillListBox();
	void	SetSampleText();
	void	SetHeightSel(int n, BOOL drawSample = FALSE);
	void	SetWeightSel(int n, BOOL drawSample = FALSE);

	static int CALLBACK EnumFontFamProc(ENUMLOGFONT* lpelf, NEWTEXTMETRIC* lpntm,
										int nFontType, LPARAM lParam);

public:
	void	SetCurFont(const LOGFONT & lf);
	LOGFONT	GetLogfont() { return m_lf; };

	LOGFONT m_lf;
	CFont m_fontSample;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FONTSETUP_H__A0348BFB_96E1_4B15_BB8D_EAAA2A729784__INCLUDED_)
